#ifndef  CLIB_DATAMASTER_PROTOS_H
#define  CLIB_DATAMASTER_PROTOS_H

/*
** $Filename: clib/datamaster_protos.h $
** $Release: 2.0 $
** $Revision: 2.0 $
**
** datamaster.library C prototypes
**
** (C) Copyright 1995-1997 Alexis Nasr, Dirk Stcker
** All Rights Reserved
*/

#ifndef LIBRARIES_DATAMASTER_H
#include <libraries/datamaster.h>
#endif

VOID dmQueryRecoList(struct RecoListOld *DestList);
VOID dmQueryRecoNames(struct RecoListOld *DestList);

APTR dmRecognize(APTR Addr, ULONG Size);
APTR dmRecognizePatt(STRPTR Name);

APTR dmTestFile(STRPTR Name, ULONG Size, ULONG Flags);

APTR dmGetRecoAddr(STRPTR Filetype, APTR CurrentAddr);
ULONG dmGetDMR_Tag(APTR Recognizer, ULONG DMR_tag);

VOID dmLockPrefs(VOID);
VOID dmUnLockPrefs(VOID);
ULONG dmScanRecoDir(STRPTR DirName);
ULONG dmAddRecoDir(STRPTR DirName);
ULONG dmAddRecoName(STRPTR RecoName);
ULONG dmAddRecoFile(STRPTR FileName);
ULONG dmRemRecoName(STRPTR Name);
ULONG dmRemRecoAddr(APTR Address);

APTR dmReadRecoFile(STRPTR FileName);
VOID dmFreeRecoFile(APTR SegAddr);

VOID dmFreeDMHandle(APTR HandleAddr);

/* -------- v2.0 additions ----- */

struct RecoList *dmQueryRecoListNew(ULONG Classes, ULONG Flags);
struct RecoList *dmQueryRecoNamesNew(ULONG Classes, ULONG Flags);
VOID dmFreeRecoList(struct RecoList *RecoList);
APTR dmTestData(APTR Addr, ULONG Size, ULONG Flags, A1 STRPTR);


/* -------- support routines ----- */

ULONG dmCmpTextC(STRPTR UserString, STRPTR RefString);
ULONG dmCmpTextNC(STRPTR UserString, STRPTR RefString);
ULONG dmCmpStringC(STRPTR UserString, STRPTR RefString);
ULONG dmCmpStringNC(STRPTR UserString, STRPTR RefString);

ULONG dmFindTextC(APTR StartAddress, STRPTR RefString, ULONG ScanSize, APTR DataStart, ULONG DataSize);
ULONG dmFindTextNC(APTR StartAddress, STRPTR RefString, ULONG ScanSize, APTR DataStart, ULONG DataSize);
ULONG dmFindStringC(APTR StartAddress, STRPTR RefString, ULONG ScanSize, APTR DataStart, ULONG DataSize);
ULONG dmFindStringNC(APTR StartAddress, STRPTR RefString, ULONG ScanSize, APTR DataStart, ULONG DataSize);

ULONG dmMatchName(STRPTR UserString, STRPTR Pattern);

VOID dmCopyString(STRPTR UserString, STRPTR Dest);
STRPTR dmCopyStringNZ(STRPTR UserString, STRPTR Dest);
ULONG dmCountString(STRPTR UserString);
STRPTR dmDupString(STRPTR UserString);

#endif   /* CLIB_DATAMASTER_PROTOS_H */
